<template>
  <main>
    <mt-page-title :link-to="{ name: 'profil-dashboard-utilisateurs' }" link-text="Annuler">
      <h1 class="has-text-weight-bold is-size-3">
        Modification d'un utilisateur<b-icon v-if="!utilisateur.enabled" icon="lock" />
      </h1>
    </mt-page-title>
    <form autocomplete="off" @submit.prevent="submit">
      <mt-champs-form-utilisateur
        :utilisateur="utilisateur"
        :corps="corps"
        :types-organismes="typesOrganismes"
        :organismes="organismes"
        :postes-ro="postesRo"
        :profils="profils"
        :type-organismes-allowed="typeOrganismesAllowed"
      />
      <div class="mt-fields-section">
        <h3 class="has-text-weight-bold">Mot de passe</h3>
        <div class="columns">
          <div class="column">
            <b-field label="Mot de passe">
              <b-input
                key="user-password"
                v-model="utilisateur.password"
                placeholder="Mot de passe"
                type="password"
                password-reveal
                class="input-login"
              />
            </b-field>
          </div>
          <div class="column">
            <b-field label="confirmez le Mot de passe">
              <b-input
                key="user-password-confirmation"
                v-model="utilisateur.passwordconfirmation"
                placeholder="Mot de passe"
                type="password"
                password-reveal
                class="input-login"
                autocomplete="off"
              />
            </b-field>
          </div>
        </div>
        <div class="control">
          <p v-if="erreur" class="help is-danger">{{ erreur }}</p>
        </div>
        <mt-password-security-meter :password="utilisateur.password" :rules="rules"></mt-password-security-meter>
      </div>
      <div class="columns is-centered">
        <b-field class="column">
          <b-button type="is-primary has-text-weight-semibold" native-type="submit" class="mt-button is-size-8">
            Enregistrer les modifications
          </b-button>
        </b-field>
        <b-field class="column">
          <b-button icon-left="lock" type="is-danger" class="mt-button is-size-8" @click="clotureUtilisateur()">
            Clôturer l'affectation
          </b-button>
        </b-field>
      </div>
    </form>
    <mt-modal-action :ouvert.sync="cloturerUtilisateur" @action="cloturer()">
      Clôturer l'affectation et désactiver l'utilisateur.
      <b-field label="Date de fin d'affectation">
        <b-datepicker
          v-model="dateFinAffectation"
          placeholder="Date de fin d'affectation"
          :first-day-of-week="1"
          :month-names="monthNames"
          :day-names="dayNames"
          :min-date="utilisateur.affectation.dateAffectation"
          required
          :date-parser="dateParse"
          editable
        />
      </b-field>
    </mt-modal-action>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtChampsFormUtilisateur from '~/components/dashboard/utilisateur/champs-form-utilisateur';
import MtPasswordSecurityMeter from '~/components/connexion/password-security-meter';
import { newUtilisateur } from '~/components/mixins/utilisateurMixin';
import newOrganisme from '~/components/mixins/organismeMixin';
import passwordRulesMixin from '~/components/mixins/passwordRulesMixin';
import MtModalAction from '~/components/modal/mt-modal-action';
import DayMonthMixin from '~/components/mixins/DayMonthMixin';

export default {
  layout: 'container-small',

  components: {
    MtModalAction,
    MtPageTitle,
    MtChampsFormUtilisateur,
    MtPasswordSecurityMeter,
  },
  mixins: [passwordRulesMixin, DayMonthMixin],
  async asyncData(context) {
    const isAdmin = context.store.getters['context/isAdmin'];
    const utilisateur = Object.assign(newUtilisateur(), await context.$api.utilisateurs.get(context.params.id));
    const [typesOrganismes, corps] = await Promise.all([
      context.$api.typesOrganismes.allWithFirstChildOrganisme(),
      context.$api.corps.full(),
    ]);
    const organismes = [];
    if (utilisateur.affectation && utilisateur.affectation.organisme && utilisateur.affectation.organisme.id) {
      organismes[2] = utilisateur.affectation.organisme.id;
      organismes[1] = utilisateur.affectation.organisme.idparent;
      if (organismes[1] == null) {
        organismes[0] = utilisateur.affectation.organisme.id;
        organismes[1] = 0;
        organismes[2] = 0;
      } else {
        const organismeParent = Object.assign(newOrganisme(), await context.$api.organismes.get(organismes[1]));
        organismes[0] = organismeParent.idparent;
        if (organismes[0] == null) {
          organismes[0] = utilisateur.affectation.organisme.idparent;
          organismes[1] = utilisateur.affectation.organisme.id;
          organismes[2] = 0;
        }
      }
      if (organismes[0] !== 0) {
        typesOrganismes[1].organismes = await context.$api.organismes.organismesByParent(organismes[0]);
        if (isAdmin) {
          typesOrganismes[1].organismes.unshift({ id: 0 });
        }
      }
      if (organismes[1] !== 0) {
        typesOrganismes[2].organismes = await context.$api.organismes.organismesByParent(organismes[1]);
        if (isAdmin) {
          typesOrganismes[2].organismes.unshift({ id: 0 });
        }
      }
    }
    const { content: postesRo } = await context.$api.postesRo.all(0, 50);
    const profils = await context.$api.utilisateurs.creationProfils();
    const typeOrganismesAllowed = await context.$api.typesOrganismes.typeOrganismesAllowed(
      context.store.getters['context/profil'],
    );
    return {
      utilisateur,
      corps,
      typesOrganismes,
      organismes,
      postesRo,
      profils,
      typeOrganismesAllowed,
      erreur: null,
      cloturerUtilisateur: false,
      dateFinAffectation: null,
      desactiverUtilisateur: false,
    };
  },

  methods: {
    clotureUtilisateur() {
      this.cloturerUtilisateur = true;
    },
    async cloturer() {
      if (this.dateFinAffectation == null) {
        const message = ' Veuillez saisir une date valide pour clôturer une affectation';
        this.$buefy.toast.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      } else {
        this.utilisateur.affectation.dateFinAffectation = this.dateFinAffectation;
        this.utilisateur.enabled = this.desactiverUtilisateur;
        await this.$api.utilisateurs.cloturerUtilisateur(this.utilisateur.id, this.utilisateur);
        this.$router.push({ name: 'profil-dashboard-utilisateurs' });
      }
    },
    async submit() {
      try {
        if (this.utilisateur.password !== this.utilisateur.passwordconfirmation) {
          this.erreur = 'Les mots de passe doivent être identiques';
        } else {
          this.utilisateur.username = this.utilisateur.email;
          await this.$api.utilisateurs.put(this.utilisateur.id, this.utilisateur);
          this.$router.push({ name: 'profil-dashboard-utilisateurs' });
          this.$buefy.toast.open({
            message: `Modification de l'utilisateur ${this.utilisateur.username} réussie !`,
            type: 'is-success',
          });
        }
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
/deep/ .security-level {
  margin-top: 0.5rem;
}
h3 {
  font-weight: bold;
  margin-bottom: 1rem;
  text-transform: uppercase !important;
}
</style>
